<?php

/***************************
 * Cellule
 *
 */
class cellule
{
	var $nextRight=null;
	var $nextBottom=null;
	var $prevLeft=null;
	var $prevTop=null;
	
	var $estLettre=true;
	var $lettre='_';
	var $defPremiereLettre='';
	
	var $defLB=null;
	var $defLR=null;
	var $defTR=null;
	var $defTB=null;
	
	var $probas=null;
	
	var $separateurH=false;
	var $separateurV=false;
	
	
	
	/////////////////////////////////////////////////
	function cleanProbas($ln='FR',$change=false)
	{
		$posH=$this->getPositionH();
		$longH=$this->getLongueurH();
		$structH=$this->getMotH();
		
		$posV=$this->getPositionV();
		$longV=$this->getLongueurV();
		$structV=$this->getMotV();
		
		$this->probas=null;
		
		if(!$this->isLettre()) return true;
		if($this->getLettre()!='_') return true;
		
		if($longH>1)
		{
			$query="SELECT DISTINCT substr(mot,$posH,1) as lettre 
				FROM mots
				WHERE mot LIKE '$structH'
				AND langue='".$ln."'"; 
			$result=mysql_query($query);
			while($row=mysql_fetch_array($result))
			{
				if($row['lettre']!='-') {
					if($longV>1)
						$this->probas[$row['lettre']]=0;
					else
						$this->probas[$row['lettre']]=1;
				}
			}
			
			if($longV>1)
			{
				$query="SELECT DISTINCT substr(mot,$posV,1) as lettre 
					FROM mots
					WHERE mot LIKE '$structV'
					AND langue='".$ln."'"; 

				$result=mysql_query($query);
				while($row=mysql_fetch_array($result))
				{
					if($row['lettre']!='-') 
					{
						if(isset($this->probas[$row['lettre']])) $this->probas[$row['lettre']]=1;
					}
				}
			}
		}
		else
		{
			if($longV>1)
			{
				$query="SELECT DISTINCT substr(mot,$posV,1) as lettre 
					FROM mots
					WHERE mot LIKE '$structV'
					AND langue='".$ln."'"; 

				$result=mysql_query($query);
				while($row=mysql_fetch_array($result))
				{
					if($row['lettre']!='-') 
					{
						if($row['lettre']!='-') $this->probas[$row['lettre']]=1;
					}
				}
			}
		}
		
		if(!is_array($this->probas))
		{
			$this->UnsetLettre();
			return false;
		}
		
		
		//Purge des lettres à 0 (pas en jointure H et V
		foreach($this->probas as $lettre=>$value)
		{
			if($value==0) unset($this->probas[$lettre]);
		}
		ksort($this->probas);
		
		
		if(count($this->probas)==0)
		{
			$this->UnsetLettre();
			return false;
		}
		elseif(count($this->probas)==1 && $change)
		{
			$t=array_keys($this->probas);
			$this->setLettre($t[0]);
			return false;
		}
		elseif(count($this->probas)<=5 && $change)
		{
			$t=array_keys($this->probas);
			$this->setLettre($t[rand(0,count($this->probas)-1)]);
			return false;
		}

		
		return true;
	}
	
	//////////////////////////////////////////
	function addDefinitions(& $mots)
	{
				
		//echo $query;
	
		if ($this->nextRight && $this->nextRight->isDebutH())
		{
			$chaine=$this->nextRight->getMotH();
			
			if(isset($mots[$chaine])) $this->defLR=$mots[$chaine];
		}
		
		if ($this->nextRight && $this->nextRight->isDebutV())
		{
			$chaine=$this->nextRight->getMotV();
			
			if(isset($mots[$chaine])) $this->defLB=$mots[$chaine];
		}
		
		if ($this->nextBottom && $this->nextBottom->isDebutH())
		{
			$chaine=$this->nextBottom->getMotH();
			
			if(isset($mots[$chaine])) $this->defTR=$mots[$chaine];
		}
		
		if ($this->nextBottom && $this->nextBottom->isDebutV())
		{
			$chaine=$this->nextBottom->getMotV();
			
			if(isset($mots[$chaine])) $this->defTB=$mots[$chaine];
		}
	}
	
	function cleanDefinitions()
	{
		
		//Test de redondance de définition
		if($this->nextRight)
		{
			if ($this->nextRight->prevTop && !$this->nextRight->prevTop->isLettre())
			{
				if ($this->nextRight->prevTop->defTB == $this->defLB) 
				{
					if ($this->getNbrDefs()>$this->nextRight->prevTop->getNbrDefs())
						$this->defLB=null;
					else
						$this->nextRight->prevTop->defTB=null;
				}
				if ($this->nextRight->prevTop->defTR == $this->defLR) 
				{
					if ($this->getNbrDefs()>$this->nextRight->prevTop->getNbrDefs())
						$this->defLR=null;
					else
						$this->nextRight->prevTop->defTR=null;
				}
			}
		}
	}
	
	function getNbrDefs()
	{
		$i=0;
		if($this->defLR) $i++;
		if($this->defLB) $i++;
		if($this->defTR) $i++;
		if($this->defTB) $i++;
		return $i;
	}
	
	function getLettre()
	{
		return $this->lettre;
	}
	
	function setLettre($lettre, $manageSep=false)
	{
		$this->lettre=substr($lettre,0,1);
		$this->estLettre=true;
		$this->probas=null;
		
		//Check si mot a séparateur
		if($manageSep && $this->isLettre() && !$this->separateurH && !$this->separateurV)
		{
			$mot=$this->getMotH();
			$query="SELECT separateurs FROM mots WHERE mot='".$mot."'";
			$result=mysql_query($query);
			while($row=mysql_fetch_array($result))
			{
				if($row['separateurs']=='X')
					$this->setSeparateursH();
			}
			
			$mot=$this->getMotV();
			$query="SELECT separateurs FROM mots WHERE mot='".$mot."'";
			$result=mysql_query($query);
			while($row=mysql_fetch_array($result))
			{
				if($row['separateurs']=='X')
					$this->setSeparateursV();
			}
		}
	}
	
	function setSeparateurs(& $seps)
	{
		if($this->isLettre() && !$this->separateurH && !$this->separateurV)
		{
			$mot=$this->getMotH();
			if(isset($seps[$mot]) && $seps[$mot]=='X') $this->setSeparateursH();
			
			$mot=$this->getMotV();
			if(isset($seps[$mot]) && $seps[$mot]=='X') $this->setSeparateursV();
		}
	}
	
	function isLettre()
	{
		return ($this->estLettre==true);
	}
	
	function hasDefinition()
	{
		return ($this->defPremiereLettre!=='');
	}
	
	function isDebutH()
	{
		if ($this->prevLeft===null) return true;
		if ($this->prevLeft->isLettre()===false) return true;
		return false;
	}
	
	function isDebutV()
	{
		if ($this->prevTop===null) return true;
		if ($this->prevTop->isLettre()===false) return true;
		return false;
	}
	
	function isFinH()
	{
		if ($this->nextRight===null) return true;
		if ($this->nextRight->isLettre()===false) return true;
		return false;
	}
	
	function isFinV()
	{
		if ($this->nextBottom===null) return true;
		if ($this->nextBottom->isLettre()===false) return true;
		return false;
	}
	
	function setPrevLeft(& $case)
	{
		$this->prevLeft=& $case;
		$case->setNextRight(& $this);
	}
	
	function setPrevTop(& $case)
	{
		$this->prevTop=& $case;
		$case->setNextBottom(& $this);
	}
	
	function setNextRight(& $case)
	{
		$this->nextRight=& $case;
	}
	
	function setNextBottom(& $case)
	{
		$this->nextBottom=& $case;
	}
	
	function getPrevLeft()
	{
		return $this->prevLeft;
	}
	
	function getPrevTop()
	{
		return $this->prevTop;
	}

	function getNextRight()
	{
		return $this->nextRight;
	}
	
	function getNextBottom()
	{
		return $this->nextBottom;
	}
	
	function UnsetLettre()
	{
		$this->estLettre=false;
		$this->lettre=".";
	}
	
	/////////////////////////////////////////////////
	function setSeparateursH()
	{
		if($this->isDebutH() && $this->isFinH()) return;
		
		$case=& $this;
		while(!$case->isDebutH()) $case=$case->getPrevLeft();
		
		while(!$case->isFinH()) 
		{
			$case->separateurH=true;
			$case=& $case->getNextRight();
		}
	}
	
	function setSeparateursV()
	{
		if($this->isDebutV() && $this->isFinV()) return;
	
		$case=& $this;
		while(!$case->isDebutV()) $case=& $case->getPrevTop();
		
		while(!$case->isFinV()) 
		{
			$case->separateurV=true;
			$case=& $case->getNextBottom();
		}
	}
	
	//////////////////////////////////////////////////
	function getLongueurH()
	{
		$compte=1;
		
		if($this->isDebutH() && $this->isFinH()) return $compte;
		
		$case=& $this;
		while(!$case->isDebutH()) $case=$case->getPrevLeft();
		
		while(!$case->isFinH()) 
		{
			$case=& $case->getNextRight();
			$compte++;
		}
		
		return $compte;	
	}
	
	function getLongueurV()
	{
		$compte=1;
		
		if($this->isDebutV() && $this->isFinV()) return $compte;
	
		$case=& $this;
		while(!$case->isDebutV()) $case=& $case->getPrevTop();
		
		while(!$case->isFinV()) 
		{
			$case=& $case->getNextBottom();
			$compte++;
		}
		
		return $compte;	
	}
	
	function getPositionH()
	{
		$compte=1;
		
		if($this->isDebutH() && $this->isFinH()) return $compte;
		
		$case=& $this;
		while(!$case->isDebutH()) 
		{
			$case=$case->getPrevLeft();
			$compte++;
		}
		
		return $compte;	
	}
	
	function getPositionV()
	{
		$compte=1;
		
		if($this->isDebutV() && $this->isFinV()) return $compte;
	
		$case=& $this;
		while(!$case->isDebutV()) {
			$case=& $case->getPrevTop();
			$compte++;
		}
		
		return $compte;	
	}
	
	function getMotH()
	{
		$mot=$this->lettre;
		
		if($this->isDebutH() && $this->isFinH()) return $mot;
		
		$mot='';
		
		$case=& $this;
		while(!$case->isDebutH()) $case=& $case->getPrevLeft();
		
		while(!$case->isFinH()) 
		{
			$mot.=$case->getLettre();
			$case=& $case->getNextRight();
		}
		
		$mot.=$case->getLettre();
		
		return $mot;	
	}
	
	
	//Trouver un mot à partir de sa structure et des lettres possibles dans les cases le formant
	function findMotH(& $mots, $ln='FR')
	{
		$structH=$this->getMotH();
		$posH=$this->getPositionH();
		
		$structV=$this->getMotV();
		$posV=$this->getPositionV();
		
		$i=1;
		
		if($this->isDebutH() && $this->isFinH()) return true;
		if(strpos($structH,'_')===false) return false;
		
		$t=null;
		$where='';
		
		$case=& $this;
		while(!$case->isDebutH()) 
			$case=& $case->getPrevLeft();

		while($case->isFinH()===false) 
		{
			if($case->probas)
			{
				foreach($case->probas as $lettre=>$void)
					$t[$i][$lettre]=1;
					
				$where.=" AND substr(mot,$i,1) IN ('".implode("','",array_keys($t[$i]))."')";
			}
			$i++;
			$case=& $case->getNextRight();
		}
		
		if($case->probas) 
		{
			foreach($case->probas as $lettre=>$void)
				$t[$i][$lettre]=1;
				
			$where.=" AND substr(mot,$i,1) IN ('".implode("','",array_keys($t[$i]))."')";
		}
		
		if(str_replace("_","",$structH)==$structH) return false;
		
		$query="SELECT mot FROM mots WHERE ";
		
		if(str_replace("_","",$structH)!=="") $query.="mot like '$structH'"; else $query.="longueur=".strlen($structH);
		
		$query.=$where;
		
		$query.=" AND langue='".$ln."' ORDER BY rand()";
				
		// $query;
		$result=mysql_query($query);
		if(mysql_num_rows($result)==0) return false;
		//echo '<br/>HORIZONTAL: '.$query;
		while($row=mysql_fetch_array($result))
		{
			if(!isset($mots[$row['mot']]))
			{
				$this->setMotH($row['mot']);
				$mots[$row['mot']]=1;
				return true;
			}
		}
		
		
		return false;
	}
	
	//////////////////////////////////////
	function findMotV(& $mots, $ln='FR')
	{
		$structH=$this->getMotH();
		$posH=$this->getPositionH();
		
		$structV=$this->getMotV();
		$posV=$this->getPositionV();
		
		$i=1;
		
		if($this->isDebutV() && $this->isFinV()) return true;
		
		$where='';
		$t=null;
		
		$case=& $this;
		while(!$case->isDebutV()) $case=& $case->getPrevTop();
		
		
		while($case->isFinV()===false) 
		{
			if($case->probas)
			{
				foreach($case->probas as $lettre=>$void)
					$t[$i][$lettre]=1;
					
				$where.=" AND substr(mot,$i,1) IN ('".implode("','",array_keys($t[$i]))."')";
			}
			$i++;
			$case=& $case->getNextBottom();
		}
		
		if($case->probas) 
		{
			foreach($case->probas as $lettre=>$void)
				$t[$i][$lettre]=1;
				
			$where.=" AND substr(mot,$i,1) IN ('".implode("','",array_keys($t[$i]))."')";
		}
		
		if(str_replace("_","",$structV)==$structV) return false;
		
		$query="SELECT mot FROM mots WHERE ";
		
		if(str_replace("_","",$structV)!=="") $query.="mot like '$structV'"; else $query.="longueur=".strlen($structV);
		
		$query.=$where;
		
		$query.=" AND langue='".$ln."' ORDER BY rand()";
				
		// $query;
		$result=mysql_query($query);
		if(mysql_num_rows($result)==0) return false;
		//echo '<br/>VERTICAL: '.$query;
		while($row=mysql_fetch_array($result))
		{
			if(!isset($mots[$row['mot']]))
			{
				$this->setMotV($row['mot']);
				$mots[$row['mot']]=1;
				return true;
			}
		}
		
		return false;
	}
	
	/////////////////////////////////////////////
	function setMotH($mot)
	{

		if($this->isDebutH() && $this->isFinH()) return;
		
		$case=& $this;
		while(!$case->isDebutH()) $case=& $case->getPrevLeft();
		$i=0;
		while(!$case->isFinH() && $i<strlen($mot)-1) 
		{
			$case->setLettre(substr($mot,$i,1));
			$case=& $case->getNextRight();
			$i++;
		}
		$case->setLettre(substr($mot,$i,1));
		$case=& $case->getNextRight();
		if($case) $case->UnsetLettre();

	}
	
	function getMotV()
	{
		$mot=$this->lettre;
		
		if($this->isDebutV() && $this->isFinV()) return $mot;
		
		$mot='';
		
		$case=& $this;
		while(!$case->isDebutV()) $case=& $case->getPrevTop();
		
		while(!$case->isFinV()) 
		{
			$mot.=$case->getLettre();
			$case=& $case->getNextBottom();
		}
		$mot.=$case->getLettre();
		
		return $mot;	
	}
	
	function setMotV($mot)
	{

		if($this->isDebutV() && $this->isFinV()) return;
		
		$case=& $this;
		while(!$case->isDebutV()) $case=& $case->getPrevTop();
		
		$i=0;
		while(!$case->isFinV() && $i<strlen($mot)-1) 
		{
			$case->setLettre(substr($mot,$i,1));
			$case=& $case->getNextBottom();
			$i++;
		}
		$case->setLettre(substr($mot,$i,1));
		$case=& $case->getNextBottom();
		if($case) $case->UnsetLettre();

	}
	
}